/*
 *	app.h
 *
 *	zbsO}bs[ǂ
 *
 *	* Sun Nov 28 04:30:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO 7 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
//#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
//#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
//#define QUICK_REPEAT_DELAY	SEC(0.25)
#define QUICK_REPEAT_DELAY	SEC(0.5)

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB
 * ܂AAvP[V̒ʏwiFɂ킹āAPAUSE_COLORIĂB
 */
#define USE_PAUSE /*{{TODO}}*/
#ifdef USE_PAUSE
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
//#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */
#endif /*USE_PAUSE*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	30			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

//#define TEXTURE_LIST	PAT0,PAT1,PAT2	/* eNX`Xg */
//#define TEXTURE_COUNT	3		/* eNX`̐ */
#define TEXTURE_LIST	PAT,BG,TITLE	/* eNX`Xg */
#define TEXTURE_COUNT	3		/* eNX`̐ */

extern const unsigned char M_ALL[];
extern const unsigned char S_HOP[];
extern const unsigned char S_GET[];

/****************************************************************************
 *	
 ****************************************************************************/

#define CELL_W		15
#define CELL_H		13

/* *.dir */
#define DIR_DN		0
#define DIR_UP		1
#define DIR_LF		2
#define DIR_RI		3

/*** MAPPY ***/
typedef struct _MAPPY {
	int stat;	/*  */
	fixed cnt;	/* ėpJE^ */
	int col;	/* W */
	int row;	/* sW */
	int dir;	/*  {DIR_*} */
	fixed x;	/* _XW(E) */
	fixed y;	/* _YW(㉺) */
	fixed z;	/* _ZW() */
	int joy;	/* ͕ێ(AChÔ) */
	fixed last_x;	/* ŏI\_XW(E) */
	fixed last_y;	/* ŏI\_YW(㉺) */
	fixed last_z;	/* ŏI\_ZW() */
	int last_sprno;	/* ŏI\XvCgԍ */
} MAPPY;

/* MAPPY.stat */
#define MAPPY_READY	0	/* EhJn */
#define MAPPY_IDLE	1	/* AChO */
#define MAPPY_MOVE	2	/* ړ(Oi) */
#define MAPPY_BACK	3	/* ړ() */
#define MAPPY_CLEAR	4	/* EhNA */
#define MAPPY_MISS	5	/* ~X */

/*** NYAMCO ***/
typedef struct _NYAMCO {
	int stat;	/*  */
	fixed cnt;	/* ėpJE^ */
	int col;	/* W */
	int row;	/* sW */
	int dir1;	/* ړ {DIR_*} */
	int dir2;	/* 񐅕ړ {DIR_RI,LF} */
	fixed x;	/* _XW(E) */
	fixed y;	/* _YW(㉺) */
	fixed z;	/* _ZW() */
	int rest_cnt;	/* xeJE^Axe0Ń_E */
	int last_dir;	/* ŏIړ(xȅ\̂) */
	int last_sprno;	/* ŏI\XvCgԍ(_Ȅ\̂) */
} NYAMCO;

/* NYAMCO.stat */
#define NYAMCO_READY	0	/* EhJn */
#define NYAMCO_MOVE	1	/* ړ */
#define NYAMCO_REST	2	/* xe */
#define NYAMCO_DOWN	3	/* _E(xeA}bs[ɓ܂ꂽ) */

/*** MEWKIES ***/
typedef struct _MEWKIES {
	int stat;	/*  */
	fixed cnt;	/* ėpJE^ */
	int col;	/* W */
	int row;	/* sW */
	int dir;	/*  {DIR_*} */
	fixed x;	/* _XW(E) */
	fixed y;	/* _YW(㉺) */
	fixed z;	/* _ZW() */
} MEWKIES;

#define MAX_MEWKIES	32

/* MEWKIES.stat */
#define MEWKIES_BLANK	-1	/*  */
#define MEWKIES_READY	0	/* EhJn */
#define MEWKIES_MOVE	1	/* ړ */

/*** ANCESTOR ***/
typedef struct _ANCESTOR {
	int stat;	/*  */
	fixed cnt;	/* ėpJE^ */
	int col;	/* W */
	int row;	/* sW */
	int dir;	/* ړ */
	fixed x;	/* _XW(E) */
	fixed y;	/* _YW(㉺) */
	fixed speed;	/* ړx */
} ANCESTOR;

/* ANCESTOR.stat */
#define ANCESTOR_BLANK	-1	/*  */
#define ANCESTOR_MOVE	0	/* ړ */

/*** TARGET ***/
typedef struct _TARGET {
	int stat;	/*  */
	int cnt;	/* ėpJE^ */
	int col;	/* W */
	int row;	/* sW */
	fixed x;	/* _XW(E) */
	fixed y;	/* _YW(㉺) */
	int kind;	/*  0..3 */
	int mult;	/* |Cg\{ 0=..,1=x2,2=x3,3=x4,4=x5 */
} TARGET;

#define MAX_TARGET	(2 * 4)

/* TARGET.stat */
#define TARGET_BLANK	-1	/*  */
#define TARGET_NORMAL	0	/* ʏ */
#define TARGET_POINT	1	/* |Cg\ */

/*** OBJ ***/
typedef struct _OBJ {
	fixed x;	/* _XW(E) */
	fixed y;	/* _YW(㉺) */
	fixed z;	/* _ZW() */
	int sprno;	/* XvCgԍ  */
} OBJ;

#define MAX_OBJS	128

/*** GAME ***/

typedef struct _GAME {
	int cols;	/* 9 or 13 or 16 */
	int rows;	/* 6 */

	int hurry_cnt;
	int hurry;	/* 0:ʏ/1:HURRY UP */

	int kind;	/* O̎擾^[Qbg */
	int mult;	/* ŏI|Cg{ */

	MAPPY mappy;
	NYAMCO nyamco;
	MEWKIES mewkies[MAX_MEWKIES];
	ANCESTOR ancestor;
	TARGET target[MAX_TARGET];

	int scroll;		/* XN[[sNZ] */
	int objnum;		/* OBJo^ */
	OBJ objs[MAX_OBJS];	/* OBJobt@ */
} GAME;

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void delay(int frame);
int demo_main();

void round_init1(int round, int seed);
void round_init2(int round, int seed);

void game_init();
void game_main();

void update(int mask);
#define UPDATE_MAPPY	 1
#define UPDATE_ENEMY	 2
#define UPDATE_TARGET	 4
#define UPDATE_BG	 8
#define UPDATE_FIX	16
#define UPDATE_ALL	(-1)

int ht_target();
int ht_enemy();

void obj_put(fixed x, fixed y, fixed z, int sprno);
void obj_disp();
void map_point(int* dx, int* dy, fixed lx, fixed ly, fixed lz);

void mappy_action();
void nyamco_action();
void mewkies_action();
void ancestor_action();
void target_action();

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
